%% The local SVD-FMM
% http://dx.doi.org/10.17864/1947.329
% Please see the README file for more information including licence.

function [R,Cinv,Distx] = corr_func(x,sd,L,func)
    r=6300; %km
   
    N = size(x,1);
    Distx = zeros(N,N);
    
    p180inv=pi/180.0e0;
    Lambda=p180inv*x(:,1);
    Phi=p180inv*x(:,2);
        
    for i=1:N
        dLambda= abs(Lambda(i)*ones(N,1)-Lambda);
        Phii=Phi(i)*ones(N,1);
        dPhi=abs(Phii-Phi);

        Anglei=2.0e0*asin(sqrt( sin(0.5e0*dPhi).^2 + cos(Phi).*cos(Phii).*sin(0.5e0*dLambda).^2));
        Distx(i,:)=squeeze(abs(r*Anglei));
    end

    Linv=1.0e0/L;
    Cinv = zeros(N);
    
    if func == "SOAR"
        C=(ones(N,N)+Linv*Distx).*exp(-Linv*Distx);
    end

    if func == "FOAR" || func == "Markov"
        C=exp(-Distx*Linv);
    end
  
    v = sd*ones(1,N);
    D = diag(v);
    R = D*C*D;
end