%% The local SVD-FMM
% http://dx.doi.org/10.17864/1947.329
% Please see the README file for more information including licence.

function d = generate_d(R,P,n,N)  
    % Threshold for reconditioning (minimum eigenvalue method).
    T=0.0e0;
    
    DD=R+P;
    [V,D]=eig(DD);
    lambda=diag(D);
  
    lambdaME = lambda;
    lambdaME(lambdaME<T)=T;
        
    gammaME = diag(lambdaME)-D;
    rDD = DD + V*gammaME*V';
    
    d=mvnrnd(zeros(N,1),rDD,n);
end